<!DOCTYPE html>
<html>
<head>
  <title>Countries</title>
  <script src="https://unpkg.com/vue"></script>
</head>
<body>
  <div id="app">

    <div>
      alones count  -  {{ alones.length }}
      groups count  - 
    </div>
    <div class="row mb-10" style="position: relative;top: 200px;left: 200px;">
        <div class="rectangle" v-for="(item, i) in matrixElements" :key="i" :style="{background: colors[item.color], top: (item.x + 1) * 40 + 'px', left: (item.y + 1) * 40 + 'px'}">
            {{ item.x }} {{ item.y }}
        </div>
    </div>

    <div class="row" style="margin-top: 20px;">
      <pre>
        {{ groups }}
      </pre>

      
    </div>
  </div>

  <script>
    var app = new Vue({
      el: '#app',
      data: {
        err: 'Invalid parameter',
        colors: {
          1: 'green',
          2: 'blue',
          3: 'orange', 
          4: 'yellow',
          5: 'red'
        },
        matrixElements: [],
        groups: [],
        alones: []
      },

      mounted() {
        this.formMap(6, 2);
      },

      methods: {
        
        formMap(N, M) {
          if ((N > 300000 || N < 1) || (M > 300000 || M < 1)) {return this.err;}
          let map = [];
          let n = 0;
          while (n <= N) {
            let m = 0;
            let k = 1;
            while (m <= M) {
              this.matrixElements.push({x: n, y: m, color: this.randomColor(), id: k});
              k++;
              m++;
            }
            n++;
          }

          if (this.matrixElements.length) {
            this.groupByColors();
          }
        },

        availableGroup(element) {
          return this.groups.find(array => {
            console.log(array);
            return array.find(item => {
              
              return item.color == element.color
                &&
                (
                  ((item.x == element.x + 1) && (item.y == element.y)) || // upper
                  ((item.x == element.x - 1) && (item.y == element.y)) || // down
                  ((item.y == element.y - 1) && (item.x == element.x)) || // left
                  ((item.y == element.y + 1) && (item.x == element.x))    // right
                )
              } 
            )
          }
            
          ); 
        },

        farAwayFromPreviousOrDifferent(element) {
          let lastGroup = this.groups[this.groups.length - 1];
          let lastElement = lastGroup[lastGroup.length - 1];
          if (element.color !== lastElement.color) {return true;}

          if (
              (
                (element.x - lastElement.x > 1) ||
                (element.y - lastElement.y > 1)
              )
            ) {
              return true;
            }

            return false;
        },

        groupByColors() {
          if (!this.matrixElements.length) {return false;}
          
          let arrayKey = 0;
          for (let i=0;i < this.matrixElements.length;i++) {
            if (this.thereIsSameAround(this.matrixElements[i])) {
              // differs from previus group last item 
              
              console.log(this.availableGroup(this.matrixElements[i]));
      
              if (this.groups.length && this.farAwayFromPreviousOrDifferent(this.matrixElements[i])) {
                console.log('far away');
                // other group
                arrayKey++;

                if (!this.groups[arrayKey]) {
                  this.groups[arrayKey] = [];
                }
                this.groups[arrayKey].push(this.matrixElements[i]);
              } else {
                console.log('close')
                if (!this.groups[arrayKey]) {
                  this.groups[arrayKey] = [];
                }
                this.groups[arrayKey].push(this.matrixElements[i]);
                //console.log('hereeee', this.groups[arrayKey]);
              }
            } else {
              // as alone country
              this.alones.push(this.matrixElements[i]);
            }
          }
        },

        thereIsSameAround(element) {
          return this.matrixElements.find(item =>
            item.color == element.color
            &&
            (
              ((item.x == element.x + 1) && (item.y == element.y)) || // upper
              ((item.x == element.x - 1) && (item.y == element.y)) || // down
              ((item.y == element.y - 1) && (item.x == element.x)) || // left
              ((item.y == element.y + 1) && (item.x == element.x))    // right
            )
          );
        },

        fromGroupsToCountries() { 

          //console.log(this.groups[1]);

          //let grouped = this._groupBy(this.groups[1], 'x');
          //console.log(grouped);

          for (let k in this.groups) {
            
            
            
            if (!this.groups[k].length) {continue;}

            for (let group of this.groups[k]) {


              console.log(group);


            }
            
            //console.log(this.groups[k]);

             
            
            let prevX = '', prevY = '';
            
            
            /*for (let i=0; i<this.groups[k].length;i++) {  // 1st group green

              
              if (i == 0) {
                prevX = this.groups[k][i].x;
                prevY = this.groups[k][i].y;
                
                this.countries[this.groups[k][i].color]['group-' + i] = [];
                this.countries[this.groups[k][i].color]['group-' + i].push(
                  this.groups[k][i]
                );
                
              } else {
                if (
                    (this.groups[k][i].x - prevX > 1) 
                    ||
                    (this.groups[k][i].y - prevY > 1)
                ) {
                  this.countries[this.groups[k][i].color].push(
                    this.groups[k][i]
                  );
                } else {
                  this.countries[this.groups[k][i].color][i].push(
                    this.groups[k][i]
                  );
                }

                prevX = this.groups[k][i].x;
                prevY = this.groups[k][i].y;
                
              

                /*this.countries[this.groups[k][i].color][i] = []; // 1
                this.countries[this.groups[k][i].color][i].push(this.groups[k][i]); 

                for (let j=i+1; j < this.groups[k].length;j++) {
                  if (
                      (this.groups[k][j].x - this.groups[k][i].x > 1) 
                      ||
                      (this.groups[k][j].y - this.groups[k][i].y > 1)
                  ) {
                    this.countries[this.groups[k][i].color][j] = [];
                    this.countries[this.groups[k][i].color][j].push(this.groups[k][j]);
                  } else {
                    this.countries[this.groups[k][i].color][i].push(this.groups[k][j]); // 1
                  } 
                }*/
              //}
            //}
          }
        },

        randomColor() {
          let colors = [1, 2, 3, 4, 5];
          return colors[Math.floor(Math.random() * colors.length)];
        },

        /*groupBy(objectArray, property) {
          return objectArray.reduce(function (acc, obj) {
            var key = obj[property];
            if (!acc[key]) {
              acc[key] = [];
            }
            acc[key].push(obj);
            return acc;
          }, {});
        },*/

        groupBy(key) {
          return function group(array) {
            return array.reduce((acc, obj) => {
              const property = obj[key];
              acc[property] = acc[property] || [];
              acc[property].push(obj);
              return acc;
            }, {});
          };
        },

        _groupBy(array, key) {
          return Array.from(array
              .reduce((m, object) => m.set(object[key], [...(m.get(object[key]) || []), object]), new Map)
              .values()
          );
        }
      }
    })
  </script>
</body>
</html>

<style>
    .rectangle {
      width: 40px;
      height: 40px;
      background: red;
      border: 1px solid black;
      position: absolute;
    }
</style>
